
#include <stdint.h>
#include <stdio.h>

enum {
//    _xinfreq = 20_000_000,
    _xtlfreq = 20_000_000,
    _clkfreq = 8_000_000,

    DOWNLOAD_BAUD = 230_400,
    DEBUG_BAUD = DOWNLOAD_BAUD,


    BUFFSIZE = 1024,    // bytes

    basepin = 40,

    MOSI = basepin+1,
    MISO = 1,  // 0 = MISO+1, 1 = MISO-1, pairing is required for simultaneous management
    CLK = basepin+2,
    CS = basepin+5,
    CPOL = 1,    // 1 true, 0 false.  SPI clocking mode, invert clock polarity
    CPHA = 1,    // 1 true, 0 false   SPI clocking mode, advance clock phase 180deg
    CSPD = 0,    // 1 true, 0 false.  Requires CPHA = 1.  This is a special high speed read data
                        // control bit used when Propspi's effective clock divider is below 6.

    SPINS = CPOL<<31 | CPHA<<30 | CSPD<<29 | MISO<<28 | MOSI<<12 | CLK<<6 | CS,
};

struct __using("propspi2.spin2") spi;

static uint32_t  sbuff[BUFFSIZE/4];


void  main( void )
{
    uint32_t  func, func1;

    printf( "   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), _clockmode() );

    func = spi.start_propspi( SPINS, sbuff, BUFFSIZE );
    printf( " PropSPI cogid = %d\n", func );

    // Slave cog is ready and waiting.  At this stage the tester program has not setup any of its pins,
    // so we are going to be glitching them from the start.


    func1 = sbuff[0];
    while( 1 )
    {
        func = sbuff[0];
        if( func != func1 )
        {
            func1 = func;    // edge detect
            printf( " Function %d\n", func );
        }
    }
}
